class SlotMachine
{
    Reel r[5];
    int velocities[5];
    int positions[5];    
    int mytexture;
    int backtexture;
    Texfont *thefont;
    // money in cents
    int money;
    int lastwin;
    
    bool ismoving(void)
    {
        return (velocities[0] ||
        velocities[1] ||
        velocities[2] ||
        velocities[3] ||
        velocities[4]);                
    }
    
    void checkwin(void)
    {
        lastwin=0;     
        int values[5] = {r[0].getvalue(positions[0]),
            r[1].getvalue(positions[1]),
            r[2].getvalue(positions[2]),
            r[3].getvalue(positions[3]),
            r[4].getvalue(positions[4])
        };     
        
        if (values[0]==values[1] && values[1]==values[2] && values[2]==values[3] && values[3]==values[4])
        {lastwin=20000; money+=lastwin;}
        else if (values[0]==values[1] && values[1]==values[2] && values[2]==values[3])
        {lastwin=2500; money+=lastwin;}
        else if (values[0]==values[1] && values[1]==values[2])
        {lastwin=500; money+=lastwin;}
        else if (values[0]==values[1])
        {lastwin=100; money+=lastwin;}                        
    }     
    
    
    public:
    
    void physicsproc(void)
    {                                               
        bool ismovingatstart = ismoving();        
        
        for (int ctr = 0; ctr < 5; ctr++)
        {            
            positions[ctr]+=min(velocities[ctr], 10+5-ctr);
            
            // if the previous reel hasn't stopped, let's not decelerate this one
            if (ctr > 0 && velocities[ctr-1]>0) continue;    
            
            velocities[ctr]--;
            if (velocities[ctr] < 0) velocities[ctr]=0;   
            
            
            if (velocities[ctr] != 9 || !(positions[ctr]%45)) continue;
            // if the velocity is 8 and the position isn't a multiple of 45,
            // then let's keep moving the position until it is a multiple 
            // of 45 degrees
            
            // please observe that the sum of the integers from 1 to 9 is 45.
            // so, if the velocity is 9 and we're at a multiple of 45 degrees
            // then we'll ultimately end up at a multiple of 45 degrees.
            
            velocities[ctr]=10;
            if (rand()%5==0) positions[ctr]++;                        
        }                
        
        if (ismovingatstart && !ismoving()) checkwin();                
    }
    
    
    SlotMachine(void)
    {
        mytexture = gettexture("thereel.jpg");        
        backtexture = gettexture("background.jpg");        
        
        memset(positions, 0, sizeof(int)*5);
        memset(velocities, 0, sizeof(int)*5);
        
        thefont = new Texfont("thefont.png");                     
        money = 2000;
        lastwin = 0;
    }
    
    ~SlotMachine(void)
    {
        delete thefont;
    }
    
    // spin the reels
    void roll(void)
    {
        if (ismoving()) return;
    if (money < 25) {MessageBox(NULL, "Sorry, you don't have enough money.", "Sorry", MB_OK); return;}
        
        for (int ctr = 0; ctr < 5; ctr++) 
        velocities[ctr] = rand()%10+10;
        
        money-=25;
        lastwin=0;
    }
    
    
    void draw(void)
    {
        glDisable(GL_LIGHTING);  
        glDisable(GL_DEPTH_TEST);                                                  
        glDepthMask(GL_FALSE);
        glTranslatef(0, 0, -1);
        
        float xdist = .77;
        float ydist = .58;
        
        glColor3f(1, 1, 1);
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D, backtexture);  
        // background
        glBegin(GL_QUADS);
        glTexCoord2f(0, 0);
        glVertex2f(-xdist, ydist);
        glTexCoord2f(1, 0);
        glVertex2f(xdist, ydist);
        glTexCoord2f(1, 1);
        glVertex2f(xdist, -ydist);
        glTexCoord2f(0, 1);        
        glVertex2f(-xdist, -ydist);
        glEnd();
        
        thefont->setbottomcolor(0, 0, 1);
        thefont->settopcolor(0, 0, 0.5);
        
        thefont->spacestring("Any key to play, ESC to exit" , -0.37, 0.43, .05, .05, -.025);
        
        thefont->settopcolor(1, 1, 0);
        thefont->setbottomcolor(1, 0.5, 0.5);        
        
        char moneystring[80];
        sprintf(moneystring, "Credits: $%d.%.2d", money/100, money%100);
        thefont->spacestring(moneystring, 0.05, -0.4, .05, .05, -.025);
        
        char lastwinstring[80];
        sprintf(lastwinstring, "Last win: $%d.%.2d", lastwin/100, lastwin%100);
        thefont->spacestring(lastwinstring, -0.45, -0.4, .05, .05, -.025);
        
        glEnable(GL_TEXTURE_2D);
        glEnable(GL_LIGHTING);  
        
        glTranslatef(0, 0, -3.5);
        glBindTexture(GL_TEXTURE_2D, mytexture);        
        glEnable(GL_CULL_FACE);
        glCullFace(GL_BACK);                    
        
        glTranslatef(-2.4, 0, 0);        
        
        // center the reel faces        
        glRotatef (-22.5, 1.0f, 0.0f, 0.0f);        
        
        for (int ctr = 0; ctr < 5; ctr++)
        {                                    
            glTranslatef(.8, 0, 0);
            glPushMatrix();
            glRotatef (positions[ctr], 1.0f, 0.0f, 0.0f);
            r[ctr].drawreel();    
            glPopMatrix();            
        }           
        glDisable(GL_CULL_FACE);                                  
    }
    
    
    
};
