#include "gd.h"
#include "alpha.h"

class Texfont
{
    int mytexture;
    char charmap[256];
    float topr, topg, topb;
    float botr, botg, botb;
    
    void drawcell(int cellnum, float startx, float starty, float width, float height)
    {
        
        float x = cellnum % 8;
        x/=8.0;
        float y = cellnum / 8;
        y/=8.0;
        
        glColor3f(topr, topg, topb);
        
        
        glBegin (GL_QUADS);
        glTexCoord2f(x, y);
        glVertex2f(startx, starty);
        
        glTexCoord2f(x+.125, y);
        glVertex2f(startx+width, starty);
        
        glColor3f(botr, botg, botb);
        
        glTexCoord2f(x+.125, y+.125);
        glVertex2f(startx+width, starty-height);
        
        glTexCoord2f(x, y+.125);
        glVertex2f(startx, starty-height);
        
        
        glEnd ();
        
    }
    
    
    void drawchar(char ch, float startx, float starty, float width, float height)
    {
        drawcell(charmap[ch], startx, starty, width, height);
    }
    
    public:
    Texfont(const char *filename)
    {        
        topr=1.0; topg=1.0; topb=1.0;
        botr=1.0; botg=1.0; botb=1.0;
        
        mytexture = getalphatexture(filename);
        
        for (int ctr = 0; ctr < 26; ctr++) charmap['a'+ctr] = ctr;
        for (int ctr = 0; ctr < 26; ctr++) charmap['A'+ctr] = ctr;
        
        for (int ctr = 0; ctr < 10; ctr++) charmap['0'+ctr] = 32+ctr;
        
        charmap['.']=48;
        charmap['$']=49;
        charmap[',']=50;
        charmap[';']=51;
        charmap[':']=52;
        
        charmap[' '] = 27;
        
    }
    
    void settopcolor(float r, float g, float b)
    {
        topr = r; topg = g; topb = b;     
    }
    
    void setbottomcolor(float r, float g, float b)
    {
        botr = r; botg = g; botb = b;          
    }
    
    void spacestring(char *string, float startx, float starty, float charwidth, float charheight, float spacing=0.0)
    {
        
        glEnable(GL_TEXTURE_2D);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);     
        glBindTexture(GL_TEXTURE_2D, mytexture);  
        for (int ctr = 0; ctr < strlen(string); ctr++) drawchar(string[ctr], startx+(charwidth+spacing)*ctr, starty, charwidth, charheight);
        
        glDisable(GL_BLEND);
        glDisable(GL_TEXTURE_2D);
        
    }
    
    
    
};
